from nealParams import *

def addNewConn(pre,post,weight):
    if (pre >= 0) and (pre <  neuronsPerSubnet):
        return [(pre,post,weight,DELAY)]
    else:
        return []

def getHEdgeTopOrBottomFrom3x3OffExcite():
    #weight = 3.5
    #weight = 2.0
    weight = 2.5
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeBottomFrom6x6OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3): 
            newConn = addNewConn(inpNeuron-(INPSIZE)-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2): 
            newConn = addNewConn(inpNeuron-(INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-(INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-(INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-(INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn 
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron-(INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron-(INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron-(INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-4)):
            newConn = addNewConn(inpNeuron-(INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeBottomFrom9x9OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2): 
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)-1,inpNeuron,weight)
            connectors = connectors + newConn
        newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
        connectors = connectors + newConn 
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-4)):
            newConn = addNewConn(inpNeuron-(2*INPSIZE)+4,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeTopFrom6x6OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3):
            newConn = addNewConn(inpNeuron-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2):
            newConn = addNewConn(inpNeuron-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getHEdgeTopFrom9x9OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        if (col > 3):
            newConn = addNewConn(inpNeuron-4,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 2):
            newConn = addNewConn(inpNeuron-3,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1):
            newConn = addNewConn(inpNeuron-2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron-1,inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,DELAY)]
        if (col < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+1,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)):
            newConn = addNewConn(inpNeuron+2,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-3)):
            newConn = addNewConn(inpNeuron+3,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getVEdgeLeftOrRightFrom3x3OffExcite():
    weight = 3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        row = inpNeuron / INPSIZE
        if (row > 0):
            newConn = addNewConn(inpNeuron-INPSIZE,inpNeuron,weight)
            connectors = connectors + newConn
        if (row > 1):
            newConn = addNewConn(inpNeuron-(2*INPSIZE),inpNeuron,weight)
            connectors = connectors + newConn
        connectors = connectors + [(inpNeuron,inpNeuron,weight,DELAY)]
        if (row < (INPSIZE-1)):
            newConn = addNewConn(inpNeuron+INPSIZE,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getVEdgeLeftFrom9x9OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        row = inpNeuron / INPSIZE
        for colOff in range (-1,2):
            for rowOff in range (-2,2):
                newConn = addNewConn(inpNeuron+rowOff+(colOff*INPSIZE),
                                     inpNeuron,weight)
                connectors = connectors + newConn

    return connectors

def getVEdgeRightFrom9x9OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        row = inpNeuron / INPSIZE
        for colOff in range (-1,2):
            for rowOff in range (2,6):
                newConn = addNewConn(inpNeuron+rowOff+(colOff*INPSIZE),
                                     inpNeuron,weight)
                connectors = connectors + newConn

    #print connectors
    return connectors


def getSEdgeTopOrBottomFrom3x3OffExcite():
    weight = 3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (col > 0) and (row < INPSIZE):
            fromNeuron = inpNeuron + INPSIZE -1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col > 1) and (row < (INPSIZE-1)):
            fromNeuron = inpNeuron + (2*INPSIZE) -2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-1)) and (row > 0):
            fromNeuron = inpNeuron - INPSIZE + 1
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn
        if (col < (INPSIZE-2)) and (row > 1):
            fromNeuron = inpNeuron - (2*INPSIZE) +2
            newConn = addNewConn(fromNeuron,inpNeuron,weight)
            connectors = connectors + newConn

    return connectors

def getSEdgeTopOrBottomFrom6x6OffInhib():
    weight = -3.6
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        row = inpNeuron / INPSIZE
        if (row < INPSIZE -2):
            newConn = addNewConn(inpNeuron,inpNeuron+INPSIZE,weight)
            connectors = connectors + newConn
        if (row < INPSIZE -3):
            newConn = addNewConn(inpNeuron,inpNeuron+(2*INPSIZE),weight)
            connectors = connectors + newConn

    return connectors

def getSEdgeTopOrBottomFrom9x9OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        row = inpNeuron / INPSIZE
        if (row > 0):
            newConn = addNewConn(inpNeuron,inpNeuron-INPSIZE,weight)
            connectors = connectors + newConn
        if (row > 1):
            newConn = addNewConn(inpNeuron,inpNeuron-(2*INPSIZE),weight)
            connectors = connectors + newConn
        #if (row < INPSIZE -2):
        #    newConn = addNewConn(inpNeuron,inpNeuron+INPSIZE,weight)
        #    connectors = connectors + newConn

    return connectors

def getSEdgeTopFrom9x9OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (col < INPSIZE-1):
            newConn = addNewConn(inpNeuron,inpNeuron+1,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+1-INPSIZE,weight)
                connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron+1+INPSIZE,weight)
                connectors = connectors + newConn

        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron,inpNeuron-1,weight)
            connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron-1+INPSIZE,weight)
                connectors = connectors + newConn

        if (col > 1):
            newConn = addNewConn(inpNeuron,inpNeuron-2,weight)
            connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron-2+INPSIZE,weight)
                connectors = connectors + newConn

    return connectors

def getSEdgeTopFrom6x6OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (col < INPSIZE-1):
            newConn = addNewConn(inpNeuron,inpNeuron+1,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+1-INPSIZE,weight)
                connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron+1+INPSIZE,weight)
                connectors = connectors + newConn

        newConn = addNewConn(inpNeuron,inpNeuron,weight)
        connectors = connectors + newConn
        if (col > 0):
            newConn = addNewConn(inpNeuron,inpNeuron-1,weight)
            connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron-1+INPSIZE,weight)
                connectors = connectors + newConn

        if (col > 1):
            newConn = addNewConn(inpNeuron,inpNeuron-2,weight)
            connectors = connectors + newConn
            if (row < INPSIZE-1):
                newConn = addNewConn(inpNeuron,inpNeuron-2+INPSIZE,weight)
                connectors = connectors + newConn

    return connectors

def getSEdgeBottomFrom9x9OffInhib():
    weight = -3.0
    connectors = []
    for inpNeuron in range (0,neuronsPerSubnet):
        col = inpNeuron % INPSIZE
        row = inpNeuron / INPSIZE
        if (col < INPSIZE-1):
            newConn = addNewConn(inpNeuron,inpNeuron+1,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+1-INPSIZE,weight)
                connectors = connectors + newConn

        if (col < INPSIZE-2):
            newConn = addNewConn(inpNeuron,inpNeuron+2,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+2-INPSIZE,weight)
                connectors = connectors + newConn

        if (col < INPSIZE-3):
            newConn = addNewConn(inpNeuron,inpNeuron+3,weight)
            connectors = connectors + newConn
            if (row > 0):
                newConn = addNewConn(inpNeuron,inpNeuron+3-INPSIZE,weight)
                connectors = connectors + newConn

        if (col < INPSIZE-4):
            newConn = addNewConn(inpNeuron,inpNeuron+4,weight)
            connectors = connectors + newConn

    return connectors

